<?php

class			BigOrNot_FloodControl
{
  /* Memcache instance */
  protected		$_cache;

  /**
   * Constructor
   *
   * @param Memcache $cache Memcache instance
   */
  public function	__construct(Memcache $cache)
  {
    $this->_cache = $cache;
  }

  /**
   * Check if user is authorized to execute an action, according to the specified interval
   *
   * @param string $actionName action name/identifier
   * @param string $userId unique user id
   * @param integer $interval minimum interval in second between two actions
   * @return bool TRUE if user is authorized to execute action, or FALSE if considered as flood
   */
  public function	isAllowed($actionName, $userId, $interval)
  {
    if (!is_string($userId) && !is_numeric($userId))
      throw new Exception('userId must be a string or a numeric value');
    if ($interval < 1)
      throw new Exception('invalid interval (min value is 1 sec)');

    $cacheId = md5('FloodControl:'.$actionName.':'.$userId);
    return ($this->_cache->add($cacheId, '1', false, $interval));
  }
}